//
//  ZegoGameUserInfo.h
//  ZegoMiniGameEngine
//
//  Created by zego on 2023/1/5.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface ZegoGameUserInfo : NSObject

/// User's ID required. Please do not fill in sensitive user information in this field, including but not limited to mobile phone number, ID number, passport number, real name, etc.
/// User ID, generated by the developer itself, a string of up to 64 bytes. Only numbers, English characters and '~', '!', '@', '#', '$', '', '^', '&', '*', '(', ')', '_', '+', '=', '-', ', ';', ''', ',', '.
@property (nonatomic, copy) NSString *userID;

/// User's name, required.
/// Please do not fill in sensitive user information in this field, including but not limited to mobile phone number, ID number, passport number, real name, etc.
/// Username, generated by the developer itself, a character string with a maximum length of no more than 256 bytes.
@property (nonatomic, copy) NSString *userName;

/// The URL of the user avatar, optional. The transport protocol needs to be HTTPS.
@property (nonatomic, copy) NSString *avatar;
@end

NS_ASSUME_NONNULL_END
